function plot_speech_frame(x,ss,L,graphicPanel,lpcms,iwindow);
%
% function to plot current speech frame using designated window

% Inputs:
%   x: current speech file, sampling rate: fsd
%   ss: starting sample in speech file for display of frame
%   L: duration of speech frame
%   graphicPanel3: graphic panel in which speech frame plot to be shown
%   lpcms: lpc analysis method (ac: autocorrelation, co: covariance, la:
%       lattice
%   iwindow: window type, 1:Hamming, 2:rectangular

% create frame of speech, weight using appropriate window, normalize frame
% so that the initial value of the frame is 1.0
    if (lpcms == 'ac')
        if (iwindow == 1)
            x1=x(ss:ss+L-1).*hamming(L);
        else
            x1=x(ss:ss+L-1)
        end
    else
        x1=x(ss:ss+L-1);
    end
    
% plot frame of speech using Hamming window in graphicPanel3
    reset(graphicPanel);
    axes(graphicPanel);
    cla;
    plot(0:L-1,x1,'k','LineWidth',2);
    xlabel('time in samples');ylabel('amplitude'); 
    grid on;axis tight;
end